package backstage_service

import (
	"github.com/gogf/gf/frame/g"
	"youngmini_server/app/model/backstage_model"
	"youngmini_server/app/utils"
)

var Dianping = serviceDianping{}

type serviceDianping struct{}

// FindAllDianping 查询所有
func (s *serviceDianping) FindAllDianping(dianping *backstage_model.DianpingFind) ([]*backstage_model.ResponseDianpingFind, int, error) {
	var res []*backstage_model.ResponseDianpingFind
	number, err := utils.RelyNumber(6)
	if err != nil {
		return nil, 0, err
	}
	g.DB().SetDebug(true)
	err = g.DB().Model("platform_dianping_account_info").LeftJoin("talent_info", "talent_id = talent_info.id").
		OmitEmpty().Where("talent_id IN(?)", number).Fields("`platform_id`,`platform_account_id`,`platform_nickname`,`submit_date`,`fans_count`,`got_like_count`,`home_page_url`,`talent_id`,visit_store_region").
		Page(dianping.IndexPage, dianping.PageSize).OrderDesc("talent_id").Scan(&res)
	if err != nil {
		return nil, 0, err
	}
	var result []*backstage_model.ResponseDianpingFind
	err = g.DB().Model("platform_dianping_account_info").LeftJoin("talent_info", "talent_id = talent_info.id").OmitEmpty().Where("talent_id IN(?)", number).
		OrderDesc("talent_id").Scan(&result)
	if err != nil {
		return nil, 0, err
	}
	num := len(result)
	return res, num, nil
}

// FindByConditionDianping 根据查询条件查询
func (s *serviceDianping) FindByConditionDianping(dianping *backstage_model.DianpingFind) ([]*backstage_model.ResponseDianpingFind, int, error) {
	var res []*backstage_model.ResponseDianpingFind
	if dianping.Dianping == nil {
		res, num, err := s.FindAllDianping(dianping)
		if err != nil {
			return nil, 0, err
		}
		return res, num, nil
	}
	number, err := utils.RelyNumber(6)
	if err != nil {
		return nil, 0, err
	}
	g.DB().SetDebug(true)
	// 拼接数据库查询字符串语句
	contact := s.contact(dianping.Dianping)
	err = g.DB().Model("platform_dianping_account_info").LeftJoin("talent_info", "talent_id = talent_info.id").
		OmitEmpty().Where(contact).Where("talent_id IN(?)", number).Fields("`platform_id`,`platform_account_id`,`platform_nickname`,`submit_date`,`fans_count`,`got_like_count`,`home_page_url`,`talent_id`,visit_store_region").
		Page(dianping.IndexPage, dianping.PageSize).OrderDesc("talent_id").Scan(&res)
	if err != nil {
		return nil, 0, err
	}
	var result []*backstage_model.ResponseDianpingFind
	err = g.DB().Model("platform_dianping_account_info").LeftJoin("talent_info", "talent_id = talent_info.id").
		OmitEmpty().Where(contact).Where("talent_id IN(?)", number).
		Scan(&result)
	if err != nil {
		return nil, 0, err
	}
	num := len(result)
	return res, num, nil
}

// RemoveAccount 账号下架操作
func (s *serviceDianping) RemoveAccount(status *backstage_model.RemoveAccountDianping) error {
	g.DB().SetDebug(true)
	_, err := g.DB().Model("platform_dianping_account_info").
		Data(g.Map{"examine_status": "3", "examine_fail_reason": status.Message}).
		OmitEmpty().Where("platform_account_id", status.PlatformAccountId).Update()
	if err != nil {
		return err
	}
	return nil
}

// 拼接数据库数据库where语句字符串
func (s *serviceDianping) contact(dianping *backstage_model.RequestDianpingFind) string {
	var res []string
	if dianping.PlatformAccountId != "" {
		res = append(res, "platform_account_id="+dianping.PlatformAccountId)
	}
	if dianping.TalentId != "" {
		res = append(res, "talent_id="+dianping.TalentId)
	}
	if len(dianping.SubmitDate) != 0 {
		res = append(res, "submit_date>'"+dianping.SubmitDate[0]+" 00:00:00' and "+
			"submit_date<'"+dianping.SubmitDate[1]+" 23:59:59'")
	}
	if len(dianping.FansCount) != 0 {
		res = append(res, "fans_count>="+dianping.FansCount[0]+" and fans_count<="+dianping.FansCount[1])
	}
	if dianping.VisitStoreRegion != "" {
		res = append(res, "visit_store_region="+dianping.VisitStoreRegion)
	}
	var result string
	for _, value := range res {
		result += " and " + value
	}
	return result
}

// FindAllById 单个查询所有
func (s *serviceDianping) FindAllById(dianping *backstage_model.RemoveAccountDianping) (*backstage_model.ResponsePlatformDianpingAccountInfo, error) {
	var res *backstage_model.ResponsePlatformDianpingAccountInfo
	err := g.DB().Model("platform_dianping_account_info").Where("talent_id", dianping.PlatformAccountId).Scan(&res)
	if err != nil {
		return nil, err
	}
	return res, nil
}
